<!DOCTYPE html><html lang="en"><head><meta charSet="utf-8"/><meta http-equiv="X-UA-Compatible" content="IE=edge"/><title>Snowflake · Merge</title><meta name="viewport" content="width=device-width"/><meta name="generator" content="Docusaurus"/><meta name="description" content="&lt;p&gt;This example demonstrates the difference between point to point links, and generalized links. Here we will show two different ways to build a network of 5 nodes where connectivity is all to all. In the first topology each node is connected to its neighbors through an explicit link. In the second topology one generalized link interconnects all the nodes.&lt;/p&gt;
"/><meta name="docsearch:language" content="en"/><meta property="og:title" content="Snowflake · Merge"/><meta property="og:type" content="website"/><meta property="og:url" content="https://mergetb.gitlab.io/index.html"/><meta property="og:description" content="&lt;p&gt;This example demonstrates the difference between point to point links, and generalized links. Here we will show two different ways to build a network of 5 nodes where connectivity is all to all. In the first topology each node is connected to its neighbors through an explicit link. In the second topology one generalized link interconnects all the nodes.&lt;/p&gt;
"/><meta property="og:image" content="https://mergetb.gitlab.io/img/logo.png"/><meta name="twitter:card" content="summary"/><meta name="twitter:image" content="https://mergetb.gitlab.io/img/logo.png"/><link rel="shortcut icon" href="/img/merge.png"/><link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/dracula.min.css"/><link rel="alternate" type="application/atom+xml" href="https://mergetb.gitlab.io/blog/atom.xml" title="Merge Blog ATOM Feed"/><link rel="alternate" type="application/rss+xml" href="https://mergetb.gitlab.io/blog/feed.xml" title="Merge Blog RSS Feed"/><script type="text/javascript" src="https://buttons.github.io/buttons.js"></script><link rel="stylesheet" href="/css/main.css"/></head><body class="sideNavVisible separateOnPageNav"><div class="fixedHeaderContainer"><div class="headerWrapper wrapper"><header><a href="/"><img class="logo" src="/img/merge-light.svg" alt="Merge"/><h2 class="headerTitleWithLogo">Merge</h2></a><div class="navigationWrapper navigationSlider"><nav class="slidingNav"><ul class="nav-site nav-site-internal"><li class="siteNavGroupActive"><a href="/docs/hello-world.html" target="_self">Experimentation</a></li><li class=""><a href="/docs/site-basics.html" target="_self">Site Hosting</a></li><li class=""><a href="/docs/portal-admin.html" target="_self">Portal Hosting</a></li><li class=""><a href="/docs/tech.html" target="_self">Technology</a></li><li class=""><a href="/blog/" target="_self">News</a></li></ul></nav></div></header></div></div><div class="navPusher"><div class="docMainWrapper wrapper"><div class="container docsNavContainer" id="docsNav"><nav class="toc"><div class="toggleNav"><section class="navWrapper wrapper"><div class="navBreadcrumb wrapper"><div class="navToggle" id="navToggler"><i></i></div><h2><i>›</i><span>Examples</span></h2><div class="tocToggler" id="tocToggler"><i class="icon-toc"></i></div></div><div class="navGroups"><div class="navGroup"><h3 class="navGroupCategoryTitle">Getting Started</h3><ul><li class="navListItem"><a class="navItem" href="/docs/hello-world.html">Hello World tl;dr</a></li><li class="navListItem"><a class="navItem" href="/docs/hello-world-tutorial.html">Hello World Tutorial</a></li></ul></div><div class="navGroup"><h3 class="navGroupCategoryTitle">Examples</h3><ul><li class="navListItem navListItemActive"><a class="navItem" href="/docs/snowflake.html">Snowflake</a></li></ul></div><div class="navGroup"><h3 class="navGroupCategoryTitle">Reference</h3><ul><li class="navListItem"><a class="navItem" href="/docs/merge-api.html">Merge API</a></li><li class="navListItem"><a class="navItem" href="/docs/toporef.html">Topology</a></li><li class="navListItem"><a class="navItem" href="/docs/well-known.html">Well Known Properties</a></li><li class="navListItem"><a class="navItem" href="/docs/image-support.html">Image Support</a></li></ul></div></div></section></div><script>
            document.addEventListener('DOMContentLoaded', function() {
              createToggler('#navToggler', '#docsNav', 'docsSliderActive');
              createToggler('#tocToggler', 'body', 'tocActive');

              const headings = document.querySelector('.toc-headings');
              headings && headings.addEventListener('click', function(event) {
                if (event.target.tagName === 'A') {
                  document.body.classList.remove('tocActive');
                }
              }, false);

              function createToggler(togglerSelector, targetSelector, className) {
                var toggler = document.querySelector(togglerSelector);
                var target = document.querySelector(targetSelector);

                if (!toggler) {
                  return;
                }

                toggler.onclick = function(event) {
                  event.preventDefault();

                  target.classList.toggle(className);
                };
              }
            });
        </script></nav></div><div class="container mainContainer"><div class="wrapper"><div class="post"><header class="postHeader"><h1 class="postHeaderTitle">Snowflake</h1></header><article><div><span><p>This example demonstrates the difference between point to point links, and generalized links. Here we will show two different ways to build a network of 5 nodes where connectivity is all to all. In the first topology each node is connected to its neighbors through an explicit link. In the second topology one generalized link interconnects all the nodes.</p>
<h2><a class="anchor" aria-hidden="true" id="point-to-point-links"></a><a href="#point-to-point-links" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Point To Point Links</h2>
<pre><code class="hljs css language-python"><span class="hljs-keyword">import</span> xir

topo = xir.Network({<span class="hljs-string">'name'</span>: <span class="hljs-string">'star'</span>})

nodes = [topo.node({
  <span class="hljs-string">'name'</span>: <span class="hljs-string">'n%s'</span>%i, 
  <span class="hljs-string">'image'</span>: <span class="hljs-string">'ubuntu-18.04'</span>
}) <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> range(<span class="hljs-number">6</span>)]

<span class="hljs-keyword">for</span> i,a <span class="hljs-keyword">in</span> enumerate(nodes):
    <span class="hljs-keyword">for</span> b <span class="hljs-keyword">in</span> nodes[i+<span class="hljs-number">1</span>:]:
        topo.link([a.endpoint(), b.endpoint()], {
            <span class="hljs-string">'latency'</span>: xir.ms(<span class="hljs-number">25</span>),
            <span class="hljs-string">'bandwidth'</span>: xir.lt(xir.mbps(<span class="hljs-number">10</span>))
        })
</code></pre>
<p><img src="/img/snowflake.png" alt=""></p>
<h2><a class="anchor" aria-hidden="true" id="generalized-link"></a><a href="#generalized-link" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Generalized Link</h2>
<pre><code class="hljs css language-python"><span class="hljs-keyword">import</span> xir

topo = xir.Network({<span class="hljs-string">'name'</span>: <span class="hljs-string">'star'</span>})

nodes = [topo.node({
  <span class="hljs-string">'name'</span>: <span class="hljs-string">'n%s'</span>%i, 
  <span class="hljs-string">'image'</span>: <span class="hljs-string">'ubuntu-18.04'</span>
}) <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> range(<span class="hljs-number">6</span>)]

link = topo.link(list(map(<span class="hljs-keyword">lambda</span> x: x.endpoint(), nodes)), {})
</code></pre>
</span></div></article></div><div class="docs-prevnext"><a class="docs-prev button" href="/docs/hello-world-tutorial.html"><span class="arrow-prev">← </span><span>Hello World Tutorial</span></a><a class="docs-next button" href="/docs/merge-api.html"><span>Merge API</span><span class="arrow-next"> →</span></a></div></div></div><nav class="onPageNav"><ul class="toc-headings"><li><a href="#point-to-point-links">Point To Point Links</a></li><li><a href="#generalized-link">Generalized Link</a></li></ul></nav></div><footer class="nav-footer" id="footer"><section class="sitemap"><a href="/" class="nav-home"><img src="/img/merge-light.svg" alt="Merge" width="66" height="58"/></a><div><h5>Docs</h5><a href="/docs/en/hello-world.html">Experimentation</a><a href="/docs/en/site-basics.html">Site Hosting</a><a href="/docs/en/portal-admin.html">Portal Hosting</a></div><div><h5>Community</h5><a href="/en/users.html">User Showcase</a><a href="https://mergetb.slack.com/">Project Chat</a></div><div><h5>More</h5><a href="/blog">Blog</a><a href="https://gitlab.com/mergetb">GitLab</a></div></section><section class="copyright">Copyright © 2018 Information Sciences Institute</section></footer></div></body></html>